Skip to main content

Dynamic Programming - Hard Level - Question 1

Dynamic Programming - Hard Level - Question 1 


Leetcode 1937 Maximum Number of Points with Cost

You are given an m x n integer matrix points (0-indexed). Starting with 0 points, you want to maximize the number of points you can get from the matrix.

To gain points, you must pick one cell in each row. Picking the cell at coordinates (r, c) will add points[r][c] to your score.

However, you will lose points if you pick a cell too far from the cell that you picked in the previous row. For every two adjacent rows r and r + 1 (where 0 <= r < m - 1), picking cells at coordinates (r, c1) and (r + 1, c2) will subtract abs(c1 - c2) from your score.

Return the maximum number of points you can achieve.

abs(x) is defined as:

x for x >= 0.

-x for x < 0.

Constraints:

m == points.length

n == points[r].length

1 <= m, n <= 10^5

1 <= m * n <= 10^5

0 <= points[r][c] <= 10^5



Analysis:

Based on the description, we can define dp[i][j] as the maximum number of points with cost choosing the points[i][j].

Except the last row, for elements in all the other rows have this transition formula:

dp[i][j] = max(dp[i+1][k] - abs(j - k)) + points[i][j], where k is from 0 to n-1.

So the time complexity is O(m*n*n), which cannot pass the big-data test case. Since this is the base for the optimization, the code is given below:


class Solution {
public:
    long long maxPoints(vector<vector<int>>& points) {
        long long res = 0, val = -1e6;
        int m = points.size(), n = points.front().size();
        vector<vector<long long>> dp(m, vector<long long>(n, 0));
        for(int i=0; i<n; ++i) {
            dp[m-1][i] = points[m-1][i];
            res = max(res, dp[m-1][i]);
        }
        for(int i=m-2; i>=0; --i) {
            for(int j=0; j<n; ++j) {
                long long t = val;
                for(int k=0; k<n; ++k) {
                    t = max(t, dp[i+1][k] - abs(j - k));
                }
                dp[i][j] = t + points[i][j];
                res = max(res, dp[i][j]);
            }
        }
        return res;
    }
};

 

Then the question becomes how to optimize the most inside loop from O(n) to constant time.

The line involved is 

t = max(t, dp[i+1][k] - abs(j-k))

So the first step can remove the abs function,

t = max(t, dp[i+1][k] - j + k), when j>=k;

t = max(t, dp[i+1][k] +j - k), when j<k;

We can re-write them as,

t = max(t, dp[i+1][k] + k) - j, when j>=k;

t = max(t, dp[i+1][k] - k) + j, when j<k;

So what we need actually is the maximum value of (dp[i][k] + k) on the left-side of j (smaller than) and the maximum value of (dp[i][k] - k) on the right-side of j(larger than).

The optimization becomes to maintain a maximum from the left and from the right, respectively, which is trivial to do. 

The overall time complexity is O(m*n) now.


See the code below:

class Solution {
public:
    long long maxPoints(vector<vector<int>>& points) {
        long long res = 0, val = -1e6;
        int m = points.size(), n = points.front().size();
        vector<vector<long long>> dp(m, vector<long long>(n, 0));
        for(int i=0; i<n; ++i) {
            dp[m-1][i] = points[m-1][i];
            res = max(res, dp[m-1][i]);
        }
        for(int i=m-2; i>=0; --i) {
            vector<long long> left(n, val), right(n, val);
            left[0] = dp[i+1][0];
            for(int j=1; j<n; ++j) left[j] = max(left[j-1], dp[i+1][j] + j);
            right[n-1] = dp[i+1][n-1] - (n-1);
            for(int j=n-2; j>=0; --j) right[j] = max(right[j+1], dp[i+1][j] - j);
            for(int j=0; j<n; ++j) {
                dp[i][j] = max(dp[i][j], points[i][j] + left[j] - j);
                dp[i][j] = max(dp[i][j], points[i][j] + right[j] + j);
                res = max(res, dp[i][j]);
            }
        }
        return res;
    }
};


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...